// click.c (1190.bicyclesonthemoon.info/click)
// The button that could activate BFTF
// 06.04.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define ONG_STATE_PATH "/eizm/data/aftertime/bftf/ongstate"
#define LOG_PATH        "/eizm/log/ong1/click.log"
#define TIMEFRAME       4
#define INDEX_PATH      "/eizm/www/time/index.htm"
#define NEWINDEX_PATH   "/eizm/www/time/ongdex.htm"
#define CP_PATH         "/bin/cp"


#include <cgi.h>
#include <time.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/wait.h>

s_cgi *cgi;
pid_t sub;
int r;

void writeHTML(FILE *file,const char *text);
int main (int argc, char *argv[]);

void writeHTML(FILE *file,const char *text)
{
	unsigned short length, i, v;
	for(i=0, length=strlen(text);i<length;++i)
	{
		v=((unsigned short)text[i])&0x00ff;
		switch (text[i])
		{
		case '\n':
		case '\"':
		case '&':
		case '<':
		case '>':
		case ' ':
		case '\r':
		case '=':
			fprintf(file,"&#%hu;",v);
			break;
		default:
			fputc(v,file);
		}
	}
}

int main (int argc, char *argv[])
{
	FILE *file;
	char *value;
	unsigned short ongFrame;
	unsigned char ongState, safeword;
	time_t now;
	struct tm *nowS;
	unsigned char h,m,s;
	unsigned long d;
	
	cgi=cgiInit();
	
	now=time(NULL);
	nowS=localtime(&now);
	d=TIMEFRAME*3600-(nowS->tm_sec+60*nowS->tm_min+3600*(nowS->tm_hour%TIMEFRAME));
	s=(unsigned char)(d%60);
	m=(unsigned char)((d/60)%60);
	h=(unsigned char)(d/3600);
	
	value=cgiGetValue(cgi,"n");
	safeword=((value!=NULL)?((strcmp(value,"NI")==0)?1:0):0);
	
	if(safeword)
	{
		file=fopen(ONG_STATE_PATH,"rt");
		if(file!=NULL)
		{
			fscanf(file,"%hhu %hu",&ongState,&ongFrame);
			fclose(file);
			if(ongState==0)
			{
				file=fopen(ONG_STATE_PATH,"wt");
				if(file!=NULL)
				{
					fprintf(file,"1 0");
					fclose(file);
				}
				sub=fork();
				if(!sub)
				{
					r=execl(CP_PATH,CP_PATH, "-f", NEWINDEX_PATH, INDEX_PATH, (char *)0);
					exit(r);
				}
				waitpid(sub,&r,0);
			}
			if(ongFrame>0)
				cgiRedirect("/ongoing.htm");
		}
		
	}
	
	file=fopen(LOG_PATH,"at");
	if(file!=NULL)
	{
		fprintf(file,"%s\n",(value!=NULL)?value:"");
		fclose(file);
	}
	
	fputs("Content-type: text/html\n\n",stdout);
	
	fputs("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">\n",stdout);
	fputs("<html lang=\"en\"><head>\n",stdout);
	fputs("<title>N = ",stdout);
	writeHTML(stdout,safeword?"2":((value!=NULL)?value:"???"));
	fputs("&bull; Bicycles on the Moon</title>\n",stdout);
	fputs("<meta http-equiv=\"Content-type\" content=\"text/html; charset=iso-8859-2\">\n",stdout);
	fputs("<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">\n",stdout);
	fputs("</head><body><center>\n",stdout);
	fputs("<a href=\"/\"><img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\"></a><br>\n",stdout);
	fputs("<H1>N = ",stdout);
	writeHTML(stdout,safeword?"2":((value!=NULL)?value:"???"));
	fputs("</H1>\n",stdout);
	if(safeword)
	{
		fputs("<table><tr><td>\n",stdout);
		fputs("<a href=\"/ongoing.htm\"><img src=\"/ongoing.png\" alt=\"the frame, a png file\" title=\"I'd highly recommend following the first commandment.\" border=\"2\"></a><br>\n",stdout);
		fputs("</td><tr align=\"right\"><td>\n",stdout);
		printf("%2hhu:%02hhu:%02hhu\n",h,m,s);
		fputs("</td><tr align=\"left\"><td>",stdout);
		fputs("You started something.<br>\n",stdout);
		fputs("You made a change that can't be reversed.<br>\n",stdout);
		fputs("Soon, you will notice a change.<br>\n",stdout);
		fputs("And then another one.<br>\n",stdout);
		fputs("And another one.<br>\n",stdout);
		fputs("<br>\n",stdout);
		fputs("Wait for it.<br>\n",stdout);
		fputs("</td></tr></table>\n",stdout);
	}
	else
	{
		fputs("<img src=\"/img/722.png\" alt=\"xkcd722\3\" border=\"0\"><br>\n",stdout);
	}
	fputs("<a href=\"/\">1190.bicyclesonthemoon.info</a>\n",stdout);
	fputs("</center></body></html>\n",stdout);
	
	return 0;
}