// generator.c (1190.bicyclesonthemoon.info/og-if-2)
// The object generator online interface
// 20.09.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define LOG_PATH "/eizm/log/ong1/generator.log"
#define FILE_PATH "/eizm/mem/ong1/generator/"
#define LOGIN0 "kxa"
#define PASSWORD0 "CFRTdsn'tapproV"
#define LOGIN1 "b"
#define LOGIN2 "fth"
#define MV_PATH "/bin/mv"
#define MAWK_PATH "/usr/bin/mawk"
#define AWK_OGDF "/eizm/pro/ong1/ogdfparse.awk"

#include <cgi.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/wait.h>


void response(char *text);
int main(int argc,char **argv);

time_t posttime;
s_cgi *cgi;
int t;
pid_t sub;

// void response(char *text)
// {
	// printf("%s%s%s%s%s%s%s%s%s%s%s%s%s",
		// "Content-type: text/html\n\n",
		// "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">\n",
		// "<html lang=\"en\"><head>\n",
		// "<title>Object Generator online &bull; Bicycles on the Moon</title>\n",
		// "<meta http-equiv=\"Content-type\" content=\"text/html; charset=iso-8859-2\">\n",
		// "<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">\n",
		// "<link rel=\"stylesheet\" href=\"/css/botm.css\">\n",
		// "</head><body>\n",
		// "<a href=\"/\"><img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\"></a>\n",
		// "<h1>Object generator online</h1><p>\n",
		// text,
		// "<br><a href=\"generator.htm\">Object generator interface</a></p>\n",
		// "<a href=\"/\">1190.bicyclesonthemoon.info</a></body></html>\n"
	// );
	// exit(0);
// }

int main(int argc, char **argv)
{
	char *login;
	char *password;
	char *n;
	char **up;
	char *filename;
	char filepath[256];
	char argp1[256];
	char argp2[256];
	char argp3[256];
	FILE *logfile;
	
	posttime=time(NULL);
	cgi=cgiInit();
	
	setvbuf(stdout, NULL, _IONBF, 0);
	dup2(fileno(stdout),fileno(stderr));
	
	login=cgiGetValue(cgi,"login");
	password=cgiGetValue(cgi,"password");
	n=cgiGetValue(cgi,"n");
	
	up=cgiGetFiles(cgi);
	if (up)
	{
		filename=cgiGetFile(cgi,up[0])->filename;
		sprintf(filepath,"%s%llu_%s",FILE_PATH,(unsigned long long)posttime,filename);
		sub=fork();
		if(sub==0)
		{
			t=execl(MV_PATH,MV_PATH,cgiGetFile(cgi,up[0])->tmpfile,filepath,(char *)0);
			exit(t);
		}
		waitpid(sub,&t,0);
	}
	else
		sprintf(filepath,"%s","---");
	
	// if(login==NULL || password==NULL || n==NULL || !up)
		// cgiRedirect("/generator.htm");
	
	logfile=fopen(LOG_PATH,"at");
	if(logfile!=NULL)
	{
		fprintf(logfile,"l=%s p=%s n=%s f=%s\n",(login!=NULL)?login:"---",(password!=NULL)?password:"---",(n!=NULL)?n:"---",filepath);
		fclose(logfile);
	}
	// else
		// response(LOG_PATH);
	printf("%s%s%s%s%s%s%s%s%s%s",
		"Content-type: text/html\n\n",
		"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">\n",
		"<html lang=\"en\"><head>\n",
		"<title>Object Generator online &bull; Bicycles on the Moon</title>\n",
		"<meta http-equiv=\"Content-type\" content=\"text/html; charset=iso-8859-2\">\n",
		"<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">\n",
		"<link rel=\"stylesheet\" href=\"/css/botm.css\">\n",
		"</head><body>\n",
		"<a href=\"/\"><img src=\"/img/botmlogo2.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\"></a>\n",
		"<h1>Object generator online</h1><p><code>\n"
	);
	if(login==NULL)
		printf("No login.\n");
	else if(password==NULL)
		printf("No password.\n");
	else if(strcmp(login,LOGIN0)==0 && strcmp(password,PASSWORD0)==0)
	{
		if(!up)
			printf("No definition file.\n");
		else if(n==NULL)
			printf("Quantity unspecified.\n");
		else
		{
			sprintf(argp1,"ogdf_name=%s",filename);
			sprintf(argp2,"q=%s",n);
			sprintf(argp3,"logf=%s",LOG_PATH);
			
			sub=fork();
			if(sub==0)
			{
				t=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_OGDF,"-v",argp1,"-v",argp2,"-v",argp3,filepath,(char *)0);
				exit(t);
			}
			waitpid(sub,&t,0);
		}
	}
	else if((strcmp(login,LOGIN0)==0 || strcmp(login,LOGIN1)==0 || strcmp(login,LOGIN2)==0))
		printf("Password incorrect.\n");
	else
		printf("Login incorrect.\n");
	printf("%s%s",
		"</code><br><br><a href=\"generator.htm\">Object generator interface</a></p>\n",
		"<a href=\"/\">1190.bicyclesonthemoon.info</a></body></html>\n"
	);
	return 0;
}