// ong.c
// The bot to ONG new frames to the viewer.
// 17.04.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define ONG_STATE_PATH "/eizm/data/aftertime/bftf/ongstate"
#define BOT4_PATH      "/eizm/pro/ong1/bot4"
#define MAX_FRAME      786 // na razie tyle
#define FRAME_PRINTF   "/eizm/data/aftertime/bftf/%hu.png"
#define ONGED_PRINTF   "/eizm/www/time/aftertime/bftf/bftf-%04hu.png"
#define NPBFIED_PRINTF "/eizm/www/time/aftertime/bftf/npbftf-%04hu.png"
#define CP_PATH        "/bin/cp"
#define NPB_PATH       "/eizm/pro/ong1/npb"

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/wait.h>

pid_t sub;
int r;

int main (int argc, char *argv[])
{
	FILE *file;
	unsigned short ongFrame;
	unsigned char ongState;
	char framePath[64];
	char ongedPath[64];
	char npbfiedPath[64];
	
	file=fopen(ONG_STATE_PATH,"rt");
	if(file!=NULL)
	{
		fscanf(file,"%hhu %hu",&ongState,&ongFrame);
		fclose(file);
	}
	else
	{
		ongState=0;
		ongFrame=0;
	}
	
	if(ongState==2&&ongFrame<MAX_FRAME)
	{
		++ongFrame;
		sprintf(framePath,FRAME_PRINTF,ongFrame);
		sprintf(ongedPath,ONGED_PRINTF,ongFrame);
		sprintf(npbfiedPath,NPBFIED_PRINTF,ongFrame);
		
		sub=fork();
		if(!sub)
		{
			r=execl(NPB_PATH,NPB_PATH,framePath,npbfiedPath,"q",(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		if(r)
			return r;
		
		sub=fork();
		if(!sub)
		{
			r=execl(CP_PATH,CP_PATH,framePath,ongedPath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
		if(r)
			return r;
		
		file=fopen(ONG_STATE_PATH,"wt");
		if(file!=NULL)
		{
			fprintf(file,"1 %hu",ongFrame);
			fclose(file);
		}
		sprintf(framePath,"-o%hu",ongFrame-1);
		sub=fork();
		if(!sub)
		{
			r=execl(BOT4_PATH,BOT4_PATH,framePath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
	}
	
	return 0;
}