// post.cpp (1190.bicyclesonthemoon.info/ct-if-p)
// The post edit interface
// 17.04.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include <cgi.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/wait.h>

#define RM_PATH "/bin/rm"
#define MV_PATH "/bin/mv"
#define CAT_PATH "/bin/cat"
#define MAWK_PATH "/usr/bin/mawk"

#define POST_PATH "/eizm/www/time/aftertime/bftf/post.htm"
#define INFO_PATH "/eizm/www/time/aftertime/bftf/info.htm"
#define MPOST_PATH "/eizm/mem/ong1/mpost/wait/"
// #define MLIST_PATH "/eizm/mem/ott/mlistaaa"
// #define MLAST_PATH "/eizm/mem/ottmirror/mlist/lastaaa"
// #define MFRONT_PATH "/eizm/www/time/ott/mfrontaaa"

#define AWK_PREVIEW "/eizm/pro/ong1/preview.awk"
#define AWK_VIEW "/eizm/pro/ong1/view.awk"
#define TEMP_PATH "/eizm/tmp/ong1/preview."
#define AWK_B2H "/eizm/pro/ong1/bb2html.awk"
#define DELIVER_PATH "/eizm/pro/ong1/deliver"

s_cgi *cgi;
pid_t sub;
int r;
FILE *tempfile;
FILE *postfile;
bool tf=false;
bool pf=false;
char temppath[256]="";
char postpath[256]="";
bool fff;

char zero='\0';
char *username = &zero;
char *subject = &zero;
char *message = &zero;
char *y = &zero;
char *m = &zero;
char *d = &zero;
char *Preview = &zero;
char *post =&zero;
char *addquote =&zero;
char *fy = &zero;
char *fm = &zero;
char *fd = &zero;
char *forcetime = &zero;
char *hidden = &zero;
char wrong[256];

void submit();
void preview (const char *text);
void writeArg(FILE *file,const char *name,const char *value, bool all);
void writeArg(FILE *file,const char *name,const char *value, char *insert);
void writeArgH(FILE *file,const char *name,const char *value, unsigned char br);
void writeArgH(FILE *file,const char *value);
void end(int m);

void end(int m)
{
	if(tf)
		fclose(tempfile);
	if(pf)
		fclose(postfile);
	sub=fork();
	if(sub==0)
	{
		r=execl(RM_PATH,RM_PATH,"-f",temppath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(pf)
	{
		sub=fork();
		if(sub==0)
		{
			r=execl(RM_PATH,RM_PATH,"-f",postpath,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
	}
	exit(m);
}

void writeArg(FILE *file,const char *name,const char *value, bool all=false)
{
	unsigned short length, i, v;
	fprintf(file,"%s=",name);
	for(i=0, length=strlen(value);i<length;++i)
	{
		v=((unsigned short)value[i])&0x00ff;
		if(((value[i]>='0'&&value[i]<='9')||(value[i]>='A'&&value[i]<='Z')||(value[i]>='a'&&value[i]<='z')
		||value[i]=='.'||value[i]=='~'||value[i]=='-'||value[i]=='_')&&(!all))
			fputc(v,file);
		else
			fprintf(file,"%%%02X",v);
	}
	fputc('\n',file);
}

void writeArg(FILE *file,const char *name,const char *value, char *insert)
{
	unsigned short length, i, v;
	fprintf(file,"%s=",name);
	for(i=0, length=strlen(insert);i<length;++i)
	{
		v=((unsigned short)insert[i])&0x00ff;
		if((insert[i]>='0'&&insert[i]<='9')||(insert[i]>='A'&&insert[i]<='Z')||(insert[i]>='a'&&insert[i]<='z')
		||insert[i]=='.'||insert[i]=='~'||insert[i]=='-'||insert[i]=='_')
			fputc(v,file);
		else
			fprintf(file,"%%%02X",v);
	}
	for(i=0, length=strlen(value);i<length;++i)
	{
		v=((unsigned short)value[i])&0x00ff;
		if((value[i]>='0'&&value[i]<='9')||(value[i]>='A'&&value[i]<='Z')||(value[i]>='a'&&value[i]<='z')
		||value[i]=='.'||value[i]=='~'||value[i]=='-'||value[i]=='_')
			fputc(v,file);
		else
			fprintf(file,"%%%02X",v);
	}
	fputc('\n',file);
}

void writeArgH(FILE *file,const char *name,const char *value, unsigned char br=0)
{
	unsigned short length, i, v;
	fprintf(file,"%s=",name);
	for(i=0, length=strlen(value);i<length;++i)
	{
		v=((unsigned short)value[i])&0x00ff;
		switch (value[i])
		{
		case '\"':
		case ' ':
			if(br&0x02)
			{
				fputc(v,file);
				break;
			}
			else
			{
				fprintf(file,"&#%hu;",v);
				break;
			}
		case '\n':
			if(br&0x01)
				fprintf(file,"<br>");
		case '\r':
			if(br&0x01)
				break;
		case '=':
		case '<':
		case '>':
		case '&':
			fprintf(file,"&#%hu;",v);
			break;
		default:
			fputc(v,file);
		}
	}
	fputc('\n',file);
}

void writeArgH(FILE *file,const char *value)
{
	unsigned short length, i, v;
	for(i=0, length=strlen(value);i<length;++i)
	{
		v=((unsigned short)value[i])&0x00ff;
		switch (value[i])
		{
		case '\"':
		case '&':
		case '<':
		case '>':
		case ' ':
		case '\r':
		case '\n':
		case '=':
			fprintf(file,"&#%hu;",v);
			break;
		default:
			fputc(v,file);
		}
	}
}

void submit()
{
	time_t posttime;
	struct tm *nowS;
	char timetext[32];
	char timenumber[32];
	char yy[8];
	char mm[4];
	char dd[4];
	char yyy[8];
	char mmm[4];
	char ddd[4];
	char arg1[256];
	unsigned char tm, td;
	unsigned short ty;
	bool deliver=false;

	posttime=time(NULL);
	nowS=localtime(&posttime);
	if(y[0]!='\0'){sscanf(y,"%hu",&ty); sprintf(yyy,"%04hu",ty); }
	if(m[0]!='\0'){sscanf(m,"%hhu",&tm);sprintf(mmm,"%02hhu",tm);}
	if(d[0]!='\0'){sscanf(d,"%hhu",&td);sprintf(ddd,"%02hhu",td);}
	
	if(!fff)
	{
		if((ty==1900+nowS->tm_year)&&(tm==1+nowS->tm_mon)&&(td==nowS->tm_mday))
			preview("Can't send this mesage to the same day it came from.");
		if(ty<1900+nowS->tm_year)
			preview("Can't send this mesage to the past. It wasn't received in the past.");
		else if(ty==1900+nowS->tm_year)
		{
			if(tm<1+nowS->tm_mon)
				preview("Can't send this mesage to the past. It wasn't received in the past.");
			else if(tm==1+nowS->tm_mon)
			{
				if(td<=nowS->tm_mday)
					preview("Can't send this mesage to the past. It wasn't received in the past.");
			}
		}
	}
	else if((ty==1900+nowS->tm_year)&&(tm==1+nowS->tm_mon)&&(td==nowS->tm_mday))
		deliver=true;
		
	sprintf(timenumber,"%llu",(unsigned long long)posttime);
	if(forcetime[0]!='\0')
		sprintf(timetext,"%s",forcetime);
	else
		strftime(timetext,31,"%e.%m.%Y %H:%M",gmtime(&posttime));
	sprintf(postpath,"%s%s",MPOST_PATH,timenumber);
	
	if(fd[0]!='\0'&&fy[0]!='\0'&&fm[0]!='\0')
	{
		sprintf(yy,"%s",fy);
		sprintf(mm,"%s",fm);
		sprintf(dd,"%s",fd);
	}
	else
	{
		posttime+=86400;
		nowS=localtime(&posttime);
		sprintf(yy,"%04d",1900+nowS->tm_year);
		sprintf(mm,"%02d",1+nowS->tm_mon);
		sprintf(dd,"%2d",nowS->tm_mday);
	}
	
	tempfile=fopen(temppath,"wt");
	if(tempfile==NULL)
		preview("Couldn't create file.");
	tf=true;
	writeArgH(tempfile,"timenumber",timenumber);
	writeArgH(tempfile,"timetext",timetext);
	writeArgH(tempfile,"BBHTML",message,1);
	writeArgH(tempfile,"BB",message,3);
	writeArgH(tempfile,"username_h",username);
	writeArgH(tempfile,"subject_h",subject);
	if(d[0]!='\0')writeArgH(tempfile,"d",ddd);
	if(m[0]!='\0')writeArgH(tempfile,"m",mmm);
	if(y[0]!='\0')writeArgH(tempfile,"y",yyy);
	writeArgH(tempfile,"yy",yy,2);
	writeArgH(tempfile,"mm",mm,2);
	writeArgH(tempfile,"dd",dd,2);
	writeArgH(tempfile,"disable_smilies","on");
	fclose(tempfile);
	tf=false;
	
	printf("Content-type: text/html\n\n");
	sprintf(arg1,"outfile=%s",temppath);
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		setvbuf(stdout, NULL, _IONBF, 0);
		dup2(fileno(stdout),fileno(stderr));
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_B2H,"-v",arg1,temppath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	
	sub=fork();
	if(sub==0)
	{
		r=execl(MV_PATH,MV_PATH,temppath,postpath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		// preview("Couldn't add post to queue.");
		preview(postpath);
	
	sprintf(arg1,"info=<p>This message has been sent successfully.<br><br><a href=\"/ct-if-v?v=wt%s%s\">View your submitted message</a><br><br><a href=\"/ct-if%s/\">Return to the chronotransponder time interface</a></p>",timenumber,(fff?"&amp;fff=fff":""),(fff?"?fff=fff":""));
	// printf("Content-type: text/html\n\n");
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_VIEW,"-v",arg1,INFO_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<HTML><body>%s</body></html>",arg1);
	
	if(deliver)
	{
		fflush(stdout);
		sub=fork();
		if(sub==0)
		{
			r=execl(DELIVER_PATH,DELIVER_PATH,(char *)0);
			exit(r);
		}
		waitpid(sub,&r,0);
	}
	
	end(0);
}
void preview (const char *text)
{
	char arg1[256];
	time_t posttime;
	struct tm *nowS;
	char yy[8];
	char mm[4];
	char dd[4];
	unsigned short ty;
	unsigned char tm,td;
	
	tempfile=fopen(temppath,"wt");
	if(tempfile==NULL)
		end(1);
	tf=true;
	
	if(d[0]=='\0'&&y[0]=='\0'&&m[0]=='\0')
	{
		posttime=time(NULL);
		posttime+=86400;
		nowS=localtime(&posttime);
		sprintf(yy,"%04d",1900+nowS->tm_year);
		sprintf(mm,"%02d",1+nowS->tm_mon);
		sprintf(dd,"%2d",nowS->tm_mday);
	}
	else
	{
		if(y[0]!='\0'){sscanf(y,"%hu",&ty); sprintf(yy,"%04hu",ty); }
		if(m[0]!='\0'){sscanf(m,"%hhu",&tm);sprintf(mm,"%02hhu",tm);}
		if(d[0]!='\0'){sscanf(d,"%hhu",&td);sprintf(dd,"%02hhu",td);}
	}
	
	writeArgH(tempfile,"HTML",message,1);
	writeArgH(tempfile,"BB",message,3);
	writeArgH(tempfile,"wrong",text);
	writeArgH(tempfile,"username",username);
	writeArgH(tempfile,"subject",subject);
	writeArgH(tempfile,"message",message);
	if(d[0]!='\0')writeArgH(tempfile,"d",dd);
	if(m[0]!='\0')writeArgH(tempfile,"m",mm);
	if(y[0]!='\0')writeArgH(tempfile,"y",yy);
	writeArgH(tempfile,"dd",fd);
	writeArgH(tempfile,"mm",fm);
	writeArgH(tempfile,"yy",fy);
	writeArgH(tempfile,"forcetime",forcetime);
	writeArgH(tempfile,"disable_smilies","on");
	writeArgH(tempfile,"addquote",addquote);
	writeArgH(tempfile,"hidden",hidden);
	fclose(tempfile);
	tf=false;
	
	printf("Content-type: text/html\n\n");
	
	sprintf(arg1,"outfile=%s",temppath);
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		setvbuf(stdout, NULL, _IONBF, 0);
		dup2(fileno(stdout),fileno(stderr));
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_B2H,"-v",arg1,temppath,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	
	// printf("Content-type: text/html\n\n");
	sprintf(arg1,"argfile=%s",temppath);
	fflush(stdout);
	sub=fork();
	if(sub==0)
	{
		r=execl(MAWK_PATH,MAWK_PATH,"-f",AWK_PREVIEW,"-v",arg1,"-v",fff?"fff=fff":"f=f",POST_PATH,(char *)0);
		exit(r);
	}
	waitpid(sub,&r,0);
	if(r)
		printf("<HTML><body><p>Ch*rpin* M*stard</p></body></html>");
	end(0);
}

int main()
{
	bool missing=false;
	
	char *arg;
	
	cgi=cgiInit();
	fff=(cgiGetValue(cgi,"fff")!=NULL);
	
	sprintf(temppath,"%s%lu",TEMP_PATH,(unsigned long)getpid());
	
	arg=cgiGetValue(cgi,"username");
	if(arg!=NULL)
		username=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Name is missing.");
	}
	
	arg=cgiGetValue(cgi,"subject");
	if(arg!=NULL)
		subject=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Subject was missing. Replaced with default value.");
	}
	
	arg=cgiGetValue(cgi,"message");
	if(arg!=NULL)
		message=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Post is empty.");
	}
	
	arg=cgiGetValue(cgi,"y");
	if(arg!=NULL)
		y=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Time not specified.");
	}
	
	arg=cgiGetValue(cgi,"m");
	if(arg!=NULL)
		m=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Time not specified.");
	}
	
	arg=cgiGetValue(cgi,"d");
	if(arg!=NULL)
		d=arg;
	else
	{
		missing=true;
		strcpy(wrong,"Time not specified.");
	}
	
	arg=cgiGetValue(cgi,"yy");
	if(arg!=NULL)
		fy=arg;
	
	arg=cgiGetValue(cgi,"mm");
	if(arg!=NULL)
		fm=arg;
	
	arg=cgiGetValue(cgi,"dd");
	if(arg!=NULL)
		fd=arg;
	
	arg=cgiGetValue(cgi,"forcetime");
	if(arg!=NULL)
		forcetime=arg;
	
	arg=cgiGetValue(cgi,"Preview");
	if(arg!=NULL)
		Preview=arg;
	
	arg=cgiGetValue(cgi,"post");
	if(arg!=NULL)
		post=arg;
		
	arg=cgiGetValue(cgi,"q");
	if(arg!=NULL)
		addquote=arg;
	
	arg=cgiGetValue(cgi,"hidden");
	if(arg!=NULL)
		hidden=arg;
	
	if(strcmp(post,"Submit")==0)
	{
		if(missing)
			preview(wrong);
		else
			submit();
	}
	else
		preview("");
	
	return 0;
	
}
