// view.c (1190.bicyclesonthemoon.info/ongoing.htm)
// the bftf viewer
// 08.04.2015
// 
// Copyright (C) 2015  Balthasar Szczepański
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as
// published by the Free Software Foundation, either version 3 of the
// License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
// 
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define TIMEFRAME 12
#define ONG_STATE_PATH "/eizm/data/aftertime/bftf/ongstate"
#define AWK_ENHANCE    "/eizm/pro/ong1/enhance.awk"
#define ENHANCE_PATH   "/eizm/mem/ong1/enh/%04hu"
#define REDIRECT       "/aftertime/viewer?story=bftf"

#include <cgi.h>
#include <time.h>
#include <stdio.h>
#include <string.h>

s_cgi *cgi;

int main (int argc, char *argv[])
{
	time_t now;
	struct tm *nowS;
	unsigned char h,m,s;
	unsigned long d;
	char *value;
	char *bb;
	char *spoiler;
	char *enhance;
	unsigned short cgiFrame, ongFrame;
	unsigned char ongState;
	char enhancepath [32];
	FILE *file;
	char alttext[256];
	char redirect[256];
	
	cgi=cgiInit();
	
	now=time(NULL);
	nowS=localtime(&now);
	d=(TIMEFRAME*3600-(nowS->tm_sec+60*nowS->tm_min+3600*(nowS->tm_hour%TIMEFRAME)))%(3600*TIMEFRAME);
	s=(unsigned char)(d%60);
	m=(unsigned char)((d/60)%60);
	h=(unsigned char)(d/3600);
	
	file=fopen(ONG_STATE_PATH,"rt");
	if(file!=NULL)
	{
		fscanf(file,"%hhu %hu",&ongState,&ongFrame);
		fclose(file);
	}
	else
		ongFrame=0;
	
	value=cgiGetValue(cgi,"f");
	if(value!=NULL)
		sscanf(value,"%hu",&cgiFrame);
	else
		cgiFrame=ongFrame;
	bb=cgiGetValue(cgi,"b");
	spoiler=cgiGetValue(cgi,"s");
	enhance=cgiGetValue(cgi,"e");
#if defined REDIRECT
	strcpy(redirect,REDIRECT);
	if(value!=NULL)
		sprintf(redirect+strlen(redirect),"&f=%s",value);
	if(bb!=NULL)
		sprintf(redirect+strlen(redirect),"&b=%s",bb);
	if(enhance!=NULL)
		sprintf(redirect+strlen(redirect),"&n=%s",enhance);
	cgiRedirect(redirect);
	return 0;
#endif
	
	if(cgiFrame>ongFrame)
	{
		strcpy(alttext,"You aren't supposed to see this frame now.");
		printf("Status: 404 Not Found (Wait for it.)\n");
	}
	else if(cgiFrame>=564)
		strcpy(alttext,"I'd highly recommend following the first commandment ...again.");
	else if(cgiFrame>549)
		strcpy(alttext,"...");
	else if(cgiFrame==549)
		strcpy(alttext,"I'd highly re");
	else if(cgiFrame>28)
		strcpy(alttext,"I'd highly recommend following the first commandment.");
	else
		strcpy(alttext,"I'd highly recommend following the first commandment. It may not look very related now. BUT IT WILL.");
	
	sprintf(enhancepath,ENHANCE_PATH,cgiFrame);
	
	printf("Content-type: text/html\n\n");
	
	puts("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"\">\n");
	puts("<html lang=\"en\"><head>\n");
	puts("<title>ONGoing &bull; Bicycles on the Moon</title>\n");
	puts("<meta http-equiv=\"Content-type\" content=\"text/html; charset=iso-8859-2\">\n");
	puts("<link rel=\"icon\" type=\"image/png\" href=\"/img/favicon.png\">\n");
	puts("<link rel=\"stylesheet\" href=\"/css/botm.css\">\n");
	puts("</head><body><center>\n");
	puts("<a href=\"/\"><img src=\"/img/botmlogo4.png\" alt=\"1190.bicyclesonthemoon.info\" border=\"0\"></a><br>\n");
	printf("<H1>%hu</H1>\n",cgiFrame);
	puts("<table cellspacing=\"0\" cellpadding=\"0\"><tr><td colspan=\"4\" width=\"414\">\n");
	if(value!=NULL)
		printf("<img src=\"/ongoing.png?f=%hu\" alt=\"the frame, a png file\" title=\"%s\" border=\"2\"><br>\n",cgiFrame,alttext);
	else
		printf("<a href=\"/ongoing.htm?f=%hu\"><img src=\"/ongoing.png\" alt=\"the frame, a png file\" title=\"%s\" border=\"2\"></a><br>\n",ongFrame,alttext);
	puts("</td><tr align=\"right\"><td colspan=\"4\" width=\"414\">");
	
	if(d!=0)
		printf("<tt><b class=\"%s\">%02hhu</b>:<b class=\"%s\">%02hhu</b>:<b class=\"%s\">%02hhu</b></tt>\n",ongState>=2?"br":"ni",h,ongState>=2?"br":"ni",m,ongState>=2?"br":"ni",s);
	else
		printf("<tt><b class=\"%s\">00</b>:<b class=\"%s\">00</b>:<b class=\"%s\">NG</b></tt>\n",ongState>=2?"br":"ni",ongState>=2?"br":"ni",ongState>=2?"br":"ni");
	
	// printf("<tt><b class=\"%s\">E</b>:<b class=\"%s\">E</b>:<b class=\"%s\">E</b></tt>\n",ongState>=2?"br":"ni",ongState>=2?"br":"ni",ongState>=2?"br":"ni");
	
	puts("</td></tr>\n");
	if(value!=NULL)
	{
		puts("<tr align=\"center\"><td width=\"104\"><a href=\"/ongoing.htm?f=0\">| &lt; 0</a></td>\n");
		if(cgiFrame>0)
			printf("<td width=\"103\"><a href=\"/ongoing.htm?f=%hu\">&lt; %hu</a>\n",cgiFrame-1,cgiFrame-1);
		else
			puts("<td width=\"103\"></td>\n");
		if(cgiFrame<ongFrame)
			printf("<td width=\"103\"><a href=\"/ongoing.htm?f=%hu\">%hu &gt;</a>\n",cgiFrame+1,cgiFrame+1);
		else
			puts("<td  width=\"103\"></td>\n");
		printf("<td width=\"104\"><a href=\"/ongoing.htm?f=%hu\">%hu &gt;|</a></tr>\n",ongFrame,ongFrame);
		if(cgiFrame<=ongFrame)
		{
			if(bb!=NULL)
			{
				printf("<tr><td colspan=\"4\"><code>[url=http://1190.bicyclesonthemoon.info/ongoing.htm?f=%hu][img]http://1190.bicyclesonthemoon.info/ongoing/bftf-%04hu.png[/img][/url]",cgiFrame,cgiFrame);
				if(spoiler!=NULL)
					printf("[spoiler]%s[/spoiler]",alttext);
				printf("</code></td></tr>\n");
				if(spoiler!=NULL && ongFrame==cgiFrame)
					printf("<tr align=\"center\"><td colspan=\"4\"><form method=\"post\" action=\"/ongoing/pleaseongthis\">[<input type=\"submit\" class=\"hl\" value=\"ONG this for me\">]</form></td></tr>\n");
				if(spoiler==NULL)
					printf("<tr align=\"center\"><td colspan=\"4\">[<a href=\"/ongoing.htm?f=%hu&amp;b=1&amp;s=1\">spoiler</a>]</td></tr>\n",cgiFrame);
			}
			else
				printf("<tr align=\"center\"><td colspan=\"4\">[<a href=\"/ongoing.htm?f=%hu&amp;b=1\">bbcode</a>]</td></tr>\n",cgiFrame);
			file=fopen(enhancepath,"rt");
			if(file!=NULL)
			{
				if(enhance==NULL)
					printf("<tr align=\"center\"><td colspan=\"4\">[<a href=\"/ongoing.htm?f=%hu&amp;e=1\">enhance</a>]</td></tr>\n",cgiFrame);
				else
				{
					puts("<tr align=\"center\"><td colspan=\"4\">");
					while(fgets(alttext,255,file)!=NULL)
						puts(alttext);
					puts("</td></tr>\n");
				}
				fclose(file);
			}
		}
		puts("<tr align=\"center\"><td colspan=\"4\"><form method=\"get\" action=\"/ongoing.htm\">go to frame:<input class=\"pt\" type=\"text\" name=\"f\" size=\"4\"><input class=\"pk\" type=\"submit\" value=\"GO\"></form></td></tr>\n");
	}
	
	puts("</table>\n");
	puts("<a href=\"/\">1190.bicyclesonthemoon.info</a>\n");
	puts("</center></body></html>\n");
	
	return 0;
}